import cleii.data.*;

import cleii.test.Chrono;

import java.util.ArrayList;
import java.util.Iterator;


public class MainClass {

	public static void main(String[] args) {
		int [] a = {1, 3, 5};	
		for (int i: a) {
			System.out.println (i);
		}
		
		
		ArrayList<Integer> aL= new ArrayList<>();
		aL.add(1);
		aL.add(2);
		aL.add(4);	
		for (int i: aL) {
			System.out.println (i);
		}
		
		
		List<Integer> l = new List<>();
		l.insert(10);
		l.insert(11);
		l.insert(12);
		
		System.out.println ("for each su lista");
		for (int i: l) {
			System.out.println (i);
		}
		
		System.out.println ("equivalente al for each");
		
		Iterable<Integer> myIterable = aL;
		Iterator<Integer> myIterator = myIterable.iterator();
		while (myIterator.hasNext()) {
			Integer myI = myIterator.next();
			System.out.println(myI);
		}
		
		
		
		//testHash (10, 50000, 5000, 100000);
		
		
	}
	
	static void testHash (int trials, int n, 
						  int sizeHEsterno, int sizeHInterno) {
		
		//var si pu usare SOLO se il tipo  chiaro e desumibile dalla inizializzazione
		var cListe= new Chrono();
		var cIntLineare = new Chrono();
		var cIntDoppio = new Chrono();
		
		//var ii=7.0;
		
		for (int j=0; j<trials; j++) {
			var tListe = new ListHashTable<Integer> (sizeHEsterno, 4);
			var tIntLineare = new LinearInspectionHashTable<Integer>
			                                      (sizeHInterno, .5);
			var tIntDoppio = new DoubleHashingHashTable<Integer>
                                           (sizeHInterno, .5);
			
			ArrayList<Integer> numeriInseriti = new ArrayList<>();
			for (int i=0; i<n;) {
				//CONTINUARE PER ESERCIZIO.
				int numero = (int) (1000000 * Math.random());
				if (!numeriInseriti.contains(numero)) {
					numeriInseriti.add(numero);
			
				cListe.start();
				tListe.insert(numero);
				cListe.stop();
				
				cIntLineare.start();
				tIntLineare.insert(numero);
				cIntLineare.stop();
				
				cIntDoppio.start();
				tIntDoppio.insert(numero);
				cIntDoppio.stop();
				
				i++;
				}
			}
		}
		
		System.out.println ("Tempo liste trabocco:  " + cListe.getTempo()/1000000 + " mS");
		System.out.println ("Tempo interno lineare: " + cIntLineare.getTempo()/1000000 + " mS");
		System.out.println ("Tempo interno doppio:  " + cIntDoppio.getTempo()/1000000 + " mS");
		
	}

}
