package cleii.data;

public class DoubleHashingHashTable<T> extends InternalHashTable<T> {
	private int k2; // il parametro del modulo della seconda funzione Hash
	
	public DoubleHashingHashTable (int k, double maxLoad) {
		super (k, maxLoad);
		k2 = getK()-1;
	}

	@Override
	protected int h(T x, int i) {
		int code = x.hashCode();
		if (code<0) code = -code;
		return ( (code % getK()) + i * (1 +  (code % k2) )  ) % getK();
	}

}
